/*
 *	main.c
 *
 *	yonbai - S{eLXgr[A
 *
 *	* Mon Sep 16 17:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

extern unsigned char SE1[];

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define SOUND_CH	1		/* SEĐ`l */

#define N_FILES		MAXDIR		/* t@Cꗗ̍ő吔 */
#define N_LINES		10000		/* eLXg̍ős   */

#define COLS		(DISP_X / 5)	/* (128/5=25...3) */
#define ROWS		(DISP_Y / 6)	/* s( 88/6=14...4) */
#define LEFT_MARGIN	1		/* ] */
#define TOP_MARGIN	2		/* ] */

/* pSpϊe[u */
const char narrow_to_wide[] =
	"@@@@@@@@@@@@@@@@"
	"@@@@@@@@@@@@@@@@"
	"@Ihfij{C|D^"
	"OPQRSTUVWXFGH"
	"`abcdefghijklmn"
	"opqrstuvwxymnOQ"
	"M"
	"obpP@"
	"@@@@@@@@@@@@@@@@"
	"@@@@@@@@@@@@@@@@"
	"@BuvAE@BDFHb"
	"[ACEGIJLNPRTVXZ\"
	"^`cegijklmnqtwz}"
	"~JK"
	"@@@@@@@@@@@@@@@@"
	"@@@@@@@@@@@@@@@@";

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

PCEWAVEINFO wave_info;			/* TEhĐp */

int redraw;				/* ĕ`tO */
int reverse;				/* OiFEwiF] */
unsigned short tbuff[ROWS][COLS];	/* eLXgobt@ */

char files[N_FILES][MAXFILENAME + 1];	/* t@Cꗗ */
int n_files;				/* t@C */
int cursel;				/* ݂̑It@Cԍ */
int curtop;				/* ʏ[̃t@Cԍ */

char* text;				/* eLXgt@Cǂݍ */
char* lines[N_LINES];			/* s̐擪ւ̃|C^ */
int n_lines;				/* s */
int curline;				/* ݂̕\擪s */
int mrkline;				/* }[Ns     */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void sound_play(unsigned char* se);
void font_extract(unsigned short code, unsigned char buff[5][5]);
void tbuff_disp();
int text_load(const char* fname);
char* tbuff_print(int col, int row, char* str);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	int i, len, prev, tmp;
	FILEINFO fi;

	/* B */
	app_init();

	/* ]\̕₷̂ŁAԂŔ]ɂĂB */
	reverse = 1;

	/* t@CXg쐬B */
	n_files = 0;
	memset(files, 0, sizeof files);
	pceFileFindOpen(&fi);
	while(n_files < N_FILES) {
		if(pceFileFindNext(&fi) == 0) break;
		len = strlen(fi.filename);
		if(len >= 4 && strcmp(&fi.filename[len - 4], ".txt") == 0) {
			strncpy(files[n_files++], fi.filename, MAXFILENAME);
		}
	}
	pceFileFindClose(&fi);
	if(n_files == 0) {
		sound_play(SE1);
		memset(tbuff, 0, sizeof tbuff);
		/*                                            OPQRSTUVWXOPQRS */
		tbuff_print((COLS - 15) / 2, (ROWS - 1) / 2, "eLXgt@C܂B");
		redraw = 1; /* ͕Kĕ` */
		for(;;) {
			schedule();
			if(joy & TRG_MASK) exit(0);
			if(redraw) {
				tbuff_disp();
				redraw = 0;
			}
		}
	}
	cursel = 0;
	curtop = 0;

	for(;;) {
		/********** t@CI **********/
RESEL:
		/* cursel,curtop͑O̒lp܂B */
		redraw = 1; /* ͕Kĕ` */
		for(;;) {
			schedule();

			/* SELECTꂽI܂B */
			if(joy & TRG_SELECT) exit(0);

			/* ImB */
			if(joy & TRG_A) break;

			/* ĕ`攻̂߂ɑIʒuoĂB */
			prev = cursel;

			/* IύXB */
			if(joy & TRG_UP) cursel--;
			if(joy & TRG_DN) cursel++;
			if(joy & TRG_LF) cursel -= (ROWS - 2/*Qs̓^Cg*/);
			if(joy & TRG_RI) cursel += (ROWS - 2/*Qs̓^Cg*/);

			/* Iʒu؂l߁BIʒuςĕ`B */
			if(cursel < 0) cursel = 0;
			if(cursel > n_files - 1) cursel = n_files - 1;
			if(curtop < cursel - ((ROWS - 2/*Qs̓^Cg*/) - 1)) curtop = cursel - ((ROWS - 2/*Qs̓^Cg*/) - 1);
			if(curtop > cursel) curtop = cursel;
			if(cursel != prev) redraw = 1;

			/* ĕ`B */
			if(redraw) {
				memset(tbuff, 0, sizeof tbuff);
				for(i = 0; i < n_files; i++) {
					if(i == cursel) tbuff_print(1, 2/*Qs̓^Cg*/ + i - curtop, "");
					tbuff_print(3, 2/*Qs̓^Cg*/ + i - curtop, files[i]);
				}
				tbuff_print(0, 0, "S{eLXgr[A"); /* Qs */
				tbuff_print(0, 1, "@@@@@@@@@@@@@@@@@@@@@@@@@"); /* }XN */
				tbuff_disp();
				redraw = 0;
			}
		}

		/* t@Cǂݍ݁B */
		if(text_load(files[cursel]) != 0) {
			sound_play(SE1);
			memset(tbuff, 0, sizeof tbuff);
			/*                                                OPQRSTUVWXOPQ */
			tbuff_print((COLS - 13) / 2, (ROWS - 1) / 2 - 1, "݂݂ς܂B");
			tbuff_print((COLS - 13) / 2, (ROWS - 1) / 2    , "t@C邩A");
			tbuff_print((COLS - 13) / 2, (ROWS - 1) / 2 + 1, "܂͂Ă܂B@@");
			redraw = 1; /* ͕Kĕ` */
			for(;;) {
				schedule();
				if(joy & TRG_MASK) break;
				if(redraw) {
					tbuff_disp();
					redraw = 0;
				}
			}
			goto RESEL; /* đI */
		}

		/********** eLXg\ **********/

		curline = 0;
		mrkline = 0;
		redraw = 1; /* ͕Kĕ` */
		for(;;) {
			schedule();

			/* SELECTꂽt@CIɖ߂܂B */
			if(joy & TRG_SELECT) break;

			/* ĕ`攻̂߂ɍsʒuoĂB */
			prev = curline;

			/* }[NEWvB */
			if(joy & TRG_A) {
				if(mrkline != curline) {
					mrkline = curline;
					sound_play(SE1);
				}
			}
			if(joy & TRG_B) {
				if(mrkline != curline) {
					sound_play(SE1);
					tmp = curline;
					          curline = mrkline;
					                    mrkline = tmp;
				}
			}

			/* sړB */
			if(joy & TRG_UP) curline--;
			if(joy & TRG_DN) curline++;
			if(joy & TRG_LF) curline -= ROWS;
			if(joy & TRG_RI) curline += ROWS;

			/* sʒu؂l߁Bsʒuςĕ`B */
			if(curline + ROWS > n_lines) curline = n_lines - ROWS;
			if(curline < 0) curline = 0;
			if(curline != prev) redraw = 1;

			/* ĕ`B */
			if(redraw) {
				memset(tbuff, 0, sizeof tbuff);
				for(i = 0; i < ROWS; i++) {
					if(curline + i > n_lines - 1) break;
					tbuff_print(0, i, lines[curline + i]);
				}
				tbuff_disp();
				redraw = 0;
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
//	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* SE`lő剹ʂɁB */
	pceWaveSetChAtt(SOUND_CH, 0);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mɃTEh~B */
	pceWaveAbort(0);
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	pceLCDTrans();		/* ʍXV */
	yield();		/* VXe */
	joy = pcePadGet();	/* pbhԍXV */
	now++;			/* O[o^C}XV */

	/* OiFEwiF]؂芷B */
	if(joy & TRG_START) {
		reverse = !reverse;
		redraw = 1; /* YȂŁI */
	}
}

void
sound_play(unsigned char* se)
{
	pceWaveAbort(SOUND_CH); /* ܂~߂I */
	memcpy(&wave_info, se + 8, sizeof(PCEWAVEINFO)); /* ݒ */
	wave_info.pData = se + 8 + sizeof(PCEWAVEINFO);
	pceWaveDataOut(SOUND_CH, &wave_info); /* ĐJn */
}

/****************************************************************************
 *	font_extract
 ****************************************************************************/

void
font_extract(unsigned short code, unsigned char buff[5][5])
{
	unsigned char tmp[10][10];
	const unsigned char* src;
	unsigned int dat;
	int x, y;

	/* tHgAhX擾B
	 * 炩pceFontSetType(0x00)ƂĂƁB
	 */
	src = pceFontGetAdrs(code);
	if((int)src & 0x80000000) { /* pw͕s */
		for(y = 0; y < 5; y++) {
			for(x = 0; x < 5; x++) {
				buff[y][x] = (x ^ y) & 1 ? 0 : 3;
			}
		}
		return;
	}

	/* 10x10tHgWJB */
	for(y = 0; y < 10; y += 2) {
		dat = src[0] << 16 | src[1] << 8 | src[2];
		src += 3;
		for(x = 0; x < 10; x++) {
			tmp[y + 0][x] = dat & 0x800000 ? 1 : 0;
			tmp[y + 1][x] = dat &    0x800 ? 1 : 0;
			dat <<= 1;
		}
	}

	/* 5x5tHgɈkB */
	for(y = 0; y < 5; y++) {
		for(x = 0; x < 5; x++) {
			buff[y][x] = tmp[y * 2 + 0][x * 2 + 0] +
				     tmp[y * 2 + 0][x * 2 + 1] +
				     tmp[y * 2 + 1][x * 2 + 0] +
				     tmp[y * 2 + 1][x * 2 + 1];
			/* 4hbgꍇA3hbgƓɖOa܂B */
			if(buff[y][x] > 3) buff[y][x] = 3;
		}
	}
}

/****************************************************************************
 *	tbuff_disp
 ****************************************************************************/

void
tbuff_disp()
{
	int col, row, x, y;
	unsigned short code;
	unsigned char buff[5][5], *src, *dst;

	pceFontSetType(0x80); /* YȂŁI */
	memset(vbuff, !reverse ? 0 : 3, sizeof vbuff);
	for(row = 0; row < ROWS; row++) {
		for(col = 0; col < COLS; col++) {
			code = tbuff[row][col];
			if(!code) continue;
			font_extract((code << 8 & 0xff00) | (code >> 8 & 0x00ff), buff);
			src = &buff[0][0];
			dst = &vbuff[DISP_X * (TOP_MARGIN + row * 6) + (LEFT_MARGIN + col * 5)];
			if(!reverse) {
				for(y = 0; y < 5; y++) {
					for(x = 0; x < 5; x++) {
						*dst++ += *src++; /* }Ⴂ܂ */
					}
					dst += DISP_X - 5;
				}
			} else {
				for(y = 0; y < 5; y++) {
					for(x = 0; x < 5; x++) {
						*dst++ -= *src++; /* }Ⴂ܂ */
					}
					dst += DISP_X - 5;
				}
			}
		}
	}
}

/****************************************************************************
 *	text_load
 ****************************************************************************/

int
text_load(const char* fname)
{
	int retval;
	FILEACC fa;
	char* str;

	free(text);
	text = NULL;

	/* t@CJ܂B */
	retval = pceFileOpen(&fa, fname, FOMD_RD);
	if(retval != 0) return -1;

	/* t@Cǂݍ݂܂B
	 * * eLXgĂāAŌSJIS1oCgڂꍇɔāA
	 *   Ōnult悤A2oCgobt@mۂĂ܂B
	 * * 傫ȃubNmۂƂɁA
	 *	calloc(oCg, 1)
	 *   ƂĂ͂܂Iۂ̊ăTCYvZOɊĒPʂ
	 *   4oCgPʂɐ؂グ̂ŁA
	 *	calloc(oCg, 4)
	 *   ƓƂɂȂĂ܂܂Î悤ɂ̂B
	 *	calloc(1, oCg)
	 */
	//text = (char*)calloc(fa.fsize + 2/*LRgQ*/, 1); ł̓_ILQ
	text = (char*)calloc(1, fa.fsize + 2/*LRgQ*/);
	if(text == NULL) {
		pceFileClose(&fa);
		return -1;
	}
	retval = file_read(&fa, text, 0, fa.fsize);
	if(retval != fa.fsize) {
		pceFileClose(&fa);
		return -1;
	}

	/* t@C܂B */
	pceFileClose(&fa);

	/* es̐擪ւ̃|C^i[܂B */
	str = text;
	n_lines = 0;
	while(n_lines < N_LINES) {
		/* sŃeLXgIĂi[܂B */
		if(*str == '\0') break;
		/* ̍s̐擪AhXi[B */
		lines[n_lines++] = str;
		/* ̍s܂œǂݔ΂܂B */
		str = tbuff_print(0, 0, str);
	}

	return 0;
}

/****************************************************************************
 *	tbuff_print
 ****************************************************************************/

char*
tbuff_print(int col, int row, char* str)
{
	unsigned char hi, lo;

	if(col < 0 || COLS - 1 < col) return str;
	if(row < 0 || ROWS - 1 < row) return str;

	while(col < COLS) {
		hi = *str++;
		if(hi == '\0') { str--; break; }	/* eLXgI(str\0w) */
		if(hi == '\r') continue;		/* CR+LFCR͖܂ */
		if(hi == '\n') break;			/* CR+LFLFōsI(str͎̍sw) */
		if((0x81 <= hi && hi <= 0x9f) || (0xe0 <= hi && hi <= 0xfc)) {
			lo = *str++; /* Sp */
		} else {
			lo = narrow_to_wide[hi * 2 + 1]; /* pSpϊ */
			hi = narrow_to_wide[hi * 2 + 0]; /* ԂɒӁI   */
		}
		((char*)&tbuff[row][col])[0] = hi;
		((char*)&tbuff[row][col])[1] = lo;
		col++;
	}

	return str;
}
